#include <cpctelera.h>
#include "gameman.h"

#include "hero.h"
#include "enemy.h"
#include "bomb.h"
#include "banner.h"
#include "mapa0.h"
#include "tiles.h"
#include "level0.h"

//DECLARATIONS//

TEntity *prota, *bomba;
TEntity *enemigo1, *enemigo2;

u8 mClock;
u8 bClock;
u8 i;
u8 muerte, muerto1, muerto2;
u8 game0; u8 nivel;

u8 epi, epi2;
u8 blas, blas2;
u8 status_changed, status_changed2;

//FUNCTIONS//

void moveEnemigo(TEntity *e){

     if (blas == 0){
        if (e->status == 1){
            if (i%2 == 0)
                if (e->x <= epi-6){
                    epi = e->y;
                    e->status = 2;
                }
        }
        else if (e->status == 2){
            if (i%2 == 0)
                if (e->y <= epi-12){
                    epi = e->x;
                    e->status = 1;
                }
        }
     }
     else {
        if (e->status == 3){
            if (i%2 == 0)
                if (e->y >= epi+12){
                    epi = e->x;
                    e->status = 0;
                }
        }
        else if (e->status == 0){
            if (i%2 == 0)
                if (e->x >= epi+6){
                    epi = e->y;
                    e->status = 3;
                }
        }
     }

    if (e->status == 0){
        if ((bomba->mover == 0) || (bomba->mover == 1 && e->y != bomba->y) || (bomba->mover == 1 && e->x != bomba->x-6)){
            e->sprite = g_enemy_3;
            EM_moveR(e);
        }
    }else if (e->status == 1){
        if ((bomba->mover == 0) || (bomba->mover == 1 && e->y != bomba->y) || (bomba->mover == 1 && e->x != bomba->x+6)){
            e->sprite = g_enemy_2;
            EM_moveL(e);
        }
    }else if (e->status == 2){
        if ((bomba->mover == 0) || (bomba->mover == 1 && e->x != bomba->x) || (bomba->mover == 1 && e->y != bomba->y+12)){
            e->sprite = g_enemy_1;
            EM_moveU(e);
        }
    }else if (e->status == 3){
        if ((bomba->mover == 0) || (bomba->mover == 1 && e->x != bomba->x) || (bomba->mover == 1 && e->y != bomba->y-12)){
            e->sprite = g_enemy_0;
            EM_moveD(e);
        }
    }

    deathTouch(e);

    if (blas == 0 && e->x == e->px && e->y == e->py){
        if(status_changed >= 12){
            blas = 1;
            status_changed = 0;
            if (e->status == 1){ e->status = 3; epi = e->x;}
            if (e->status == 2){ e->status = 0; epi = e->y;}
        }

        if(e->status == 1){
            e->status = 2;
            epi = e->y;
            status_changed++;
        }else if(e->status == 2){
            e->status = 1;
            epi = e->x;
            status_changed++;
        }

    }else if (blas == 1 && e->x == e->px && e->y == e->py){
        if(status_changed >= 12){
            blas = 0;
            status_changed = 0;
            if (e->status == 0){ e->status = 1; epi = e->x;}
            if (e->status == 3){ e->status = 2; epi = e->y;}
        }

        if(e->status == 0){
            e->status = 3;
            epi = e->y;
            status_changed++;
        }else if(e->status == 3){
            e->status = 0;
            epi = e->x;
            status_changed++;
        }

    }

    if (nivel == 0){
        if (blas == 1 && e->x == 64 && e->y == 128){
            blas = 0;
            epi = e->y;
            e->status = 2;
            status_changed = 0;
        }
    }else{
        if (blas == 1 && e->x == 70 && e->y == 140){
            blas = 0;
            epi = e->x;
            e->status = 1;
            status_changed = 0;
        }
    }
    if (blas == 0 && e->x == 4 && e->y == 8){
        blas = 1; epi= e->y;
        e->status = 3;
        status_changed = 0;
    }
}

void moveEnemigo2(TEntity *e){

     if (blas2 == 0){
        if (e->status == 1){
            if (i%2 == 0)
                if (e->x <= epi2-6){
                    epi2 = e->y;
                    e->status = 3;
                }
        }
        else if (e->status == 3){
            if (i%2 == 0)
                if (e->y >= epi2+12){
                    epi2 = e->x;
                    e->status = 1;
                }
        }
     }
     else {
        if (e->status == 2){
            if (i%2 == 0)
                if (e->y <= epi2-12){
                    epi2 = e->x;
                    e->status = 0;
                }
        }
        else if (e->status == 0){
            if (i%2 == 0)
                if (e->x >= epi2+6){
                    epi2 = e->y;
                    e->status = 2;
                }
        }
     }

    if (e->status == 0){
        if ((bomba->mover == 0) || (bomba->mover == 1 && e->y != bomba->y) || (bomba->mover == 1 && e->x != bomba->x-6)){
            e->sprite = g_enemy_3;
            EM_moveR(e);
        }
    }else if (e->status == 1){
        if ((bomba->mover == 0) || (bomba->mover == 1 && e->y != bomba->y) || (bomba->mover == 1 && e->x != bomba->x+6)){
            e->sprite = g_enemy_2;
            EM_moveL(e);
        }
    }else if (e->status == 2){
        if ((bomba->mover == 0) || (bomba->mover == 1 && e->x != bomba->x) || (bomba->mover == 1 && e->y != bomba->y+12)){
            e->sprite = g_enemy_1;
            EM_moveU(e);
        }
    }else if (e->status == 3){
        if ((bomba->mover == 0) || (bomba->mover == 1 && e->x != bomba->x) || (bomba->mover == 1 && e->y != bomba->y-12)){
            e->sprite = g_enemy_0;
            EM_moveD(e);
        }
    }

    deathTouch(e);

    if (blas2 == 0 && e->x == e->px && e->y == e->py){
        if(status_changed2 >= 12){
            blas2 = 1;
            status_changed2 = 0;
            if (e->status == 1){ e->status = 2; epi2 = e->x;}
            if (e->status == 3){ e->status = 0; epi2 = e->y;}
        }

        if(e->status == 1){
            e->status = 3;
            epi2 = e->y;
            status_changed2++;
        }else if(e->status == 3){
            e->status = 1;
            epi2 = e->x;
            status_changed2++;
        }

    }else if (blas2 == 1 && e->x == e->px && e->y == e->py){
        if(status_changed2 >= 12){
            blas2 = 0;
            status_changed2 = 0;
            if (e->status == 0){ e->status = 1; epi2 = e->x;}
            if (e->status == 2){ e->status = 3; epi2 = e->y;}
        }

        if(e->status == 0){
            e->status = 2;
            epi2 = e->y;
            status_changed2++;
        }else if(e->status == 2){
            e->status = 0;
            epi2 = e->x;
            status_changed2++;
        }

    }

    if (nivel == 0){
        if (blas2 == 1 && e->x == 64 && e->y == 8){
            blas2 = 0;
            epi2 = e->x;
            e->status = 1;
            status_changed2 = 0;
        }
        if (blas2 == 0 && e->x == 4 && e->y == 128){
            blas2 = 1; epi2= e->x;
            e->status = 0;
            status_changed2 = 0;
        }
    }else{
        if (blas2 == 1 && e->x == 70 && e->y == 8){
            blas2 = 0;
            epi2 = e->x;
            e->status = 1;
            status_changed2 = 0;
        }
        if (e->x == 4 && e->y == 140){
            blas2 = 1; epi2= e->x;
            e->status = 0;
            status_changed2 = 0;
        }
    }
}


void deathTouch(TEntity *e){
    if (e->x+1 >= prota->x && e->x+1 <= prota->x+6 && e->y+2  >= prota->y && e->y+2  <= prota->y+12 ||
        e->x+5 >= prota->x && e->x+5 <= prota->x+6 && e->y+2  >= prota->y && e->y+2  <= prota->y+12 ||
        e->x+1 >= prota->x && e->x+1 <= prota->x+6 && e->y+10 >= prota->y && e->y+10 <= prota->y+12 ||
        e->x+5 >= prota->x && e->x+5 <= prota->x+6 && e->y+10 >= prota->y && e->y+10 <= prota->y+12)

        muerte = 1;
}

void bombaClock(){
    if(bomba->mover == 1){
        bClock++;

        if (bClock == 1){
            bomba->sprite = g_bomb_00;
            EM_draw(bomba);
        }
        else if (bClock == 25){
            bomba->sprite = g_bomb_01;
            EM_draw(bomba);
        }
        else if (bClock == 50){
            bomba->sprite = g_bomb_02;
            EM_draw(bomba);
        }
        else if (bClock == 75){
            bomba->sprite = g_bomb_03;
            EM_draw(bomba);
        }
        else if (bClock == 100){
            bomba->sprite = g_bomb_04;
            EM_draw(bomba);
        }

        if (bClock == 125){
            EM_clear(bomba);
            draw_explosion(bomba);

            muerte = damage_explosion(prota,bomba);
            if (muerto1)
                muerto1 = damage_explosion(enemigo1,bomba);
            if (muerto2)
                muerto2 = damage_explosion(enemigo2,bomba);

            if (muerto1 == 0 && muerto2 == 0){
                nivel++;
                if (nivel > 4){
                    //WIN // GAME OVER//
                    ////////////////////
                    cpct_drawStringM0 ("YOU WIN"
                        ,  cpctm_screenPtr(CPCT_VMEM_START, 28, 70)
                        ,  15, 1);
                    cpct_drawStringM0 ("THANKS FOR PLAYING"
                        ,  cpctm_screenPtr(CPCT_VMEM_START, 4, 90)
                        ,  15, 1);
                    ////////////////////
                    //
                }else{
                    GM_startgame();
                    victory(nivel);
                }
            }
        }
        else if (bClock == 150){

            undraw_explosion(bomba);
            bClock = 0;
            bomba->mover = 0;
            //bomba->sprite = g_bomb_00;

        }
    }
}

void comprobarTeclado() {
	cpct_scanKeyboard_if();

	if (cpct_isAnyKeyPressed()) {
        if (cpct_isKeyPressed(Key_Space)){
            if (bomba->mover == 0)
                EM_PonerBomba(prota, bomba);
        }

        if (cpct_isKeyPressed(Key_CursorLeft)){
            prota->sprite = g_hero_2;
            if ((bomba->mover == 0) || (bomba->mover == 1 && prota->y != bomba->y) || (bomba->mover == 1 && prota->x != bomba->x+6)){
                mClock ++;
                if (mClock == 2){
                    EM_moveL(prota);
                    mClock = 0;
                }
            }
        }else if (cpct_isKeyPressed(Key_CursorRight)){
            prota->sprite = g_hero_3;
            if ((bomba->mover == 0) || (bomba->mover == 1 && prota->y != bomba->y) || (bomba->mover == 1 && prota->x != bomba->x-6)){
                mClock ++;
                if (mClock == 2){
                    EM_moveR(prota);
                    mClock = 0;
                }
            }
        }else if (cpct_isKeyPressed(Key_CursorUp)){
            prota->sprite = g_hero_1;
            if ((bomba->mover == 0) || (bomba->mover == 1 && prota->x != bomba->x) || (bomba->mover == 1 && prota->y != bomba->y+12))
                EM_moveU(prota);
        }else if (cpct_isKeyPressed(Key_CursorDown)){
            prota->sprite = g_hero_0;
            if ((bomba->mover == 0) || (bomba->mover == 1 && prota->x != bomba->x) || (bomba->mover == 1 && prota->y != bomba->y-12))
                EM_moveD(prota);
        }

        prota->mover = 1;
    }
}


// INITIALIZER
void GM_initialize(){
    cpct_disableFirmware();
	cpct_setVideoMode(0);
	cpct_setBorder(HW_BLACK);
	cpct_setPalette(g_palette, 16);

    cpct_etm_setTileset2x4(g_tileset);

    dibujarRotulo();
    game0 = 0;
}

//GM_startmenu
void GM_startmenu () {

   while (1) {
      u16 c = 1000;

      cpct_drawStringM0 ("ANY KEY TO START"
                        ,  cpctm_screenPtr(CPCT_VMEM_START, 0, 70)
                        ,  15, 1);
      cpct_drawStringM0 ("MOVE: ARROW KEYS"
                        ,  cpctm_screenPtr(CPCT_VMEM_START, 0, 90)
                        ,  15, 1);
      cpct_drawStringM0 ("SPACEBAR: BOMB"
                        ,  cpctm_screenPtr(CPCT_VMEM_START, 0,110)
                        ,  15, 1);

      while (--c) {
        cpct_scanKeyboard_if();

        if (cpct_isAnyKeyPressed())
            return;
        cpct_waitVSYNC();
      }
   }
}

//BANNER
void dibujarRotulo() {
	cpct_drawSprite (g_banner_0,
					 cpctm_screenPtr(CPCT_VMEM_START, 0, 0)
					,G_BANNER_0_W, G_BANNER_0_H);
	cpct_drawSprite (g_banner_1,
					 cpctm_screenPtr(CPCT_VMEM_START, G_BANNER_0_W, 0)
					,G_BANNER_1_W, G_BANNER_1_H);
}

//Start Game
void GM_startgame(){

    cpct_akp_musicInit(song);

	mClock = 0;
	bClock = 0;
	i      = 0;
	muerte = 0;
	blas   = 0;
    blas2   = 0;
    status_changed2= 0;
    status_changed = 0;

    if (game0 == 0){
        game0 = 1;
        nivel = 0;
        dibujarMapa();
        prota    = EM_createEntity(0, 0, 0);
        bomba    = EM_createEntity(0, 0, 2);
        enemigo1 = EM_createEntity(0, 0, 1);
        enemigo2 = EM_createEntity(0, 0, 1);

    }else
        undraw_explosion(bomba);

    prota->mover= 1;
    prota->x    = 4;  prota->y    = 20;
    enemigo1->x = 70; enemigo1->y = 140;
    enemigo2->x = 70; enemigo2->y = 8;

    enemigo1->status = 1;
    enemigo2->status = 1;
    muerto1 = 1;
    muerto2 = 1;
    bomba->mover = 0;

    if (nivel == 0){
        enemigo1->x = 64; enemigo1->y = 128;
        enemigo2->x = 64; enemigo2->y = 8;

        enemigo1->status = 2;
        enemigo2->status = 1;
    }

    epi = enemigo1->y;
    epi2 = enemigo2->x;

    EM_clear(bomba);
	EM_draw(prota);
	EM_draw(enemigo1);
	EM_draw(enemigo2);

}

//GM_update
void GM_update() {

    if (muerte == 1){
        nivel = 0;
        victory(nivel);
        GM_startgame();
    }

    bombaClock();
   	comprobarTeclado();
    if (i%2 == 0){
        if (muerto1 == 1)
            moveEnemigo(enemigo1);
        if (muerto2 == 1)
            moveEnemigo2(enemigo2);
    }
    i++;

    if (i == 255)
        i=0;

//   EM_update();
//   EM_clear();
    cpct_waitVSYNC();
    cpct_akp_musicPlay();
    if (cpct_akp_songLoopTimes > 0)
            cpct_akp_musicInit(song);
}

//GM_draw
void GM_draw() {
//   EM_draw();
//   cpct_setBorder(HW_GREEN);
//   cpct_waitVSYNC();
//   SM_switchScreenBuffers();

    if (muerto1 == 1)
        EM_redraw(enemigo1);
    if (muerto2 == 1)
        EM_redraw(enemigo2);


    if (prota->mover == 1) {
//        cpct_waitVSYNC();
   		EM_redraw(prota);
   		prota->mover = 0;
 	}
}
